import re

def strip_html(s):
    s = re.sub(r'\s+', ' ', s)
    s = re.sub(r'\</?[Pp]\>', '\n\n', s)
    s = re.sub(r'\<[Bb][Rr].*?\>', '\n', s)
    lines = s.split('\n')
    ret = []

    lastblank = 0
    for line in lines:
        line = line.strip()
        blank = not line
        #print `line`, blank, lastblank
        if (not blank) or (not lastblank):
            ret.append(line)
            #print "->in"
        lastblank = blank

    while len(ret) and ret[0] == '': ret.pop(0)
    while len(ret) and ret[-1] == '': ret.pop()
    return "\n".join(ret)

def strip(s):
    if s.startswith('<'):
        return strip_html(s)
    return s

if __name__ == '__main__':
	print strip('''<p>this is   a post    in html</p><p>here\'s a second paragraph         </p>

<p>there are                   lots

of


<a href="http://foo.com/">spaces</a>  in
          this    text
          but it should
come out as one line</p>


            <p>third paragraph</p>now here's some text with <br>line breaks<br/> foo foo foooo      <BR/>heh''')
